INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('dashboard'),'LORIS HELP: Using the Database','Welcome to the LORIS database. \r\nThis Help section provides you with guidelines for adding and updating information in the database. On each page, click on the question-mark icon in the Menu Bar across the top of the screen to access detailed information specific to the page.\r\n\r\nUpon logging into the LORIS database, the user will come to the home page. Here, key user information can automatically be seen at the right-hand side of the Menu Bar at the top of the screen indicating the user’s name and the site to which the user belongs. To return to the home page at any time, the user can click on the \"LORIS\" button at the far left corner of the Menu Bar.\r\nThe menus spanning horizontally across the Menu Bar represent different categories of features within the database that allow data acquisition, storage, processing and dissemination using the web based interface. Please note that when accessing LORIS via tablet, mobile device, or in a narrow-width desktop browser window, these main menus will be hidden under the downward-pointing arrow icon in the Menu Bar. Clicking on this button will show or hide all main menus in a vertical list.\r\nThere are five main drop-down menus: Candidate, Clinical, Imaging, Reports and Admin. Hover over on each menu to display a list of features or modules, organized by category:\r\n- Candidate: New Profile, Access Profile\r\n- Clinical: Reliability Coding, Conflict Resolver, Certification, Document Repository\r\n- Imaging: Radiological Review, DICOM Archive, Imaging Browser, Imaging Uploader\r\n- Reports: Database Statistics, Data Dictionary, Data Querying Tool, Data Team Helper, Data Integrity Tool\r\n- Admin: User Accounts, Instrument Builder\r\n\r\nOn the right side of the Menu Bar there are two icons linking to the Feedback Module, a pencil on paper icon , and Help, a question mark icon. Each of these modules will open in a new pop-up window, or new tab on a mobile browser.\r\n\r\nAll five main menus, the two icons listed above, the user’s site and the user’s name are accessible from any page in LORIS, via the Menu Bar at the top of the screen. \r\n\r\nTo log out of the database, click on the username displayed at the right edge of the Menu Bar, and select the \"Log Out\" option from the drop-down menu. \r\n\r\nThe \"My Preferences\" feature, also listed in this menu, can be used to update certain user profile settings and change the user’s password. \r\n','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='LORIS HELP: Using the Database','Welcome to the LORIS database. \r\nThis Help section provides you with guidelines for adding and updating information in the database. On each page, click on the question-mark icon in the Menu Bar across the top of the screen to access detailed information specific to the page.\r\n\r\nUpon logging into the LORIS database, the user will come to the home page. Here, key user information can automatically be seen at the right-hand side of the Menu Bar at the top of the screen indicating the user’s name and the site to which the user belongs. To return to the home page at any time, the user can click on the \"LORIS\" button at the far left corner of the Menu Bar.\r\nThe menus spanning horizontally across the Menu Bar represent different categories of features within the database that allow data acquisition, storage, processing and dissemination using the web based interface. Please note that when accessing LORIS via tablet, mobile device, or in a narrow-width desktop browser window, these main menus will be hidden under the downward-pointing arrow icon in the Menu Bar. Clicking on this button will show or hide all main menus in a vertical list.\r\nThere are five main drop-down menus: Candidate, Clinical, Imaging, Reports and Admin. Hover over on each menu to display a list of features or modules, organized by category:\r\n- Candidate: New Profile, Access Profile\r\n- Clinical: Reliability Coding, Conflict Resolver, Certification, Document Repository\r\n- Imaging: Radiological Review, DICOM Archive, Imaging Browser, Imaging Uploader\r\n- Reports: Database Statistics, Data Dictionary, Data Querying Tool, Data Team Helper, Data Integrity Tool\r\n- Admin: User Accounts, Instrument Builder\r\n\r\nOn the right side of the Menu Bar there are two icons linking to the Feedback Module, a pencil on paper icon , and Help, a question mark icon. Each of these modules will open in a new pop-up window, or new tab on a mobile browser.\r\n\r\nAll five main menus, the two icons listed above, the user’s site and the user’s name are accessible from any page in LORIS, via the Menu Bar at the top of the screen. \r\n\r\nTo log out of the database, click on the username displayed at the right edge of the Menu Bar, and select the \"Log Out\" option from the drop-down menu. \r\n\r\nThe \"My Preferences\" feature, also listed in this menu, can be used to update certain user profile settings and change the user’s password. \r\n';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,NULL,'Instruments - Guide', 'For each instrument in a visit, the user needs to mark Administration as \"All\", \"Partial\" or \"None\" and mark Data Entry as \"Complete\" in order to save the form. If the instrument includes a Validity flag, Validity needs to be marked as \"Valid\", \"Questionable\" or \"Invalid\". \r\nNote the administration status is an indication of whether a particular instrument was conducted at the given time point. Administration, Data Entry status (and Validity, if applicable) can be found within the far left panel. Data Entry is automatically marked as \"In Progress\" once the user opens an instrument form. \r\n\r\nThe \"Top\" or first page of each instrument requires the user to enter the \"Date of Administration\" and \"Examiner\". \"Date of administration\" refers to the date the testing was performed. \"Examiner\" refers to the name of the person that performed the testing.\r\nSome instruments include all fields for data entry in one page, whereas other instruments include questions that have been organized onto different pages. These additional pages can be accessed through the far left panel under the heading \"Subtests\". In order to mark Data Entry as \"Complete\", all items across all pages need to be filled out. After completing data entry for a page, please click the button \"Save Data\", found at the bottom of the page. Any items for which no data is entered in the paper form should be marked as \"Not Answered\" in the database. If this option is selected for any field, a note in golden text will appear indicating \"Any entered data will not be saved\". Additional data entry for fields already marked with \"not_answered\" will also be disabled. \r\n\r\nAfter saving all data for a specific instrument, certain values specific to the instrument will be automatically calculated by the database and will appear on the first page of the form. For instance, \"Candidate Age\" is automatically calculated based on the amount of time that has passed between the \"Date of Administration\" and the Candidate’s Date of Birth (entered when the candidate’s profile was first created).\r\n\r\nOnce data for an instrument have been fully entered, and the \"Administration\" and \"Validity\" have been selected, Data Entry can be marked as \"Complete\" as previously mentioned. It is important to enter data in all required fields, otherwise the database will not allow the user to proceed with data entry completion. When viewing an Instrument Form in a narrow browser window or on a mobile device, the navigation panel typically found to the left is hidden. The instrument navigation panel contains the Administration Menu, the Validity Menu, the Data Entry Menu, and the Subtest Menu. Similar to the visit panel, it can be accessed and hidden by selecting the list icon at the left edge of the Menu Bar.\r\nLastly, the user can return to the visit through the white banner near the top of the screen and clicking \"TimePoint <i>visit</i> Details\". ','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='For each instrument in a visit, the user needs to mark Administration as \"All\", \"Partial\" or \"None\" and mark Data Entry as \"Complete\" in order to save the form. If the instrument includes a Validity flag, Validity needs to be marked as \"Valid\", \"Questionable\" or \"Invalid\". \r\nNote the administration status is an indication of whether a particular instrument was conducted at the given time point. Administration, Data Entry status (and Validity, if applicable) can be found within the far left panel. Data Entry is automatically marked as \"In Progress\" once the user opens an instrument form. \r\n\r\nThe \"Top\" or first page of each instrument requires the user to enter the \"Date of Administration\" and \"Examiner\". \"Date of administration\" refers to the date the testing was performed. \"Examiner\" refers to the name of the person that performed the testing.\r\nSome instruments include all fields for data entry in one page, whereas other instruments include questions that have been organized onto different pages. These additional pages can be accessed through the far left panel under the heading \"Subtests\". In order to mark Data Entry as \"Complete\", all items across all pages need to be filled out. After completing data entry for a page, please click the button \"Save Data\", found at the bottom of the page. Any items for which no data is entered in the paper form should be marked as \"Not Answered\" in the database. If this option is selected for any field, a note in golden text will appear indicating \"Any entered data will not be saved\". Additional data entry for fields already marked with \"not_answered\" will also be disabled. \r\n\r\nAfter saving all data for a specific instrument, certain values specific to the instrument will be automatically calculated by the database and will appear on the first page of the form. For instance, \"Candidate Age\" is automatically calculated based on the amount of time that has passed between the \"Date of Administration\" and the Candidate’s Date of Birth (entered when the candidate’s profile was first created).\r\n\r\nOnce data for an instrument have been fully entered, and the \"Administration\" and \"Validity\" have been selected, Data Entry can be marked as \"Complete\" as previously mentioned. It is important to enter data in all required fields, otherwise the database will not allow the user to proceed with data entry completion. When viewing an Instrument Form in a narrow browser window or on a mobile device, the navigation panel typically found to the left is hidden. The instrument navigation panel contains the Administration Menu, the Validity Menu, the Data Entry Menu, and the Subtest Menu. Similar to the visit panel, it can be accessed and hidden by selecting the list icon at the left edge of the Menu Bar.\r\nLastly, the user can return to the visit through the white banner near the top of the screen and clicking \"TimePoint <i>visit</i> Details\".';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('new_profile'),'New Profile','By clicking on \"New Profile\" under the Candidate Menu, users with appropriate permissions can register a new candidate for their study site. Once inside the \"New Profile\" page, the \"Date of Birth\" field must be entered twice, in order to minimize error in data entry. \r\nThe PSCID refers to an alphanumeric identifier entered by the user. This identifier is typically comprised of a site-specific code (e.g., AAA), followed by a numeric code specific to the candidate at that site (e.g., AAA0000). Other fields are customized for specific projects and can be configured as drop-down fields or user input fields. \r\n\r\nOnce all the required data fields are completed, the user can click on the \"Create\" button to finish registering the candidate. It is crucial that no mistakes in data entry are made at this point, as information cannot be modified after clicking the \"Create\" button. \r\n\r\nEach new candidate will then be assigned a 6 digit numerical DCC-ID. The DCCID, along with the previously entered PSCID, will always be used to identify this candidate.\r\n' ,'2014-09-01 00:00:00', NULL)
ON DUPLICATE KEY UPDATE content='By clicking on \"New Profile\" under the Candidate Menu, users with appropriate permissions can register a new candidate for their study site. Once inside the \"New Profile\" page, the \"Date of Birth\" field must be entered twice, in order to minimize error in data entry. \r\nThe PSCID refers to an alphanumeric identifier entered by the user. This identifier is typically comprised of a site-specific code (e.g., AAA), followed by a numeric code specific to the candidate at that site (e.g., AAA0000). Other fields are customized for specific projects and can be configured as drop-down fields or user input fields. \r\n\r\nOnce all the required data fields are completed, the user can click on the \"Create\" button to finish registering the candidate. It is crucial that no mistakes in data entry are made at this point, as information cannot be modified after clicking the \"Create\" button. \r\n\r\nEach new candidate will then be assigned a 6 digit numerical DCC-ID. The DCCID, along with the previously entered PSCID, will always be used to identify this candidate.\r\n';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('candidate_list'),'Access Profile','In many cases, the candidate`s profile will already be created. The Access Profile module, also found under the Candidate menu, allows the user to efficiently search for an existing candidate and access the related data. \r\n\r\nThere are 3 main ways to search for a candidate:\r\n\r\n<u>Option 1:</u> Using PSC-ID and DCC-ID\r\nA specific candidate profile can be accessed directly by entering both the PSC-ID and the DCC-ID in the white boxes to the right of the screen and then clicking the button \"Open Profile\". In a narrow browser window or mobile device the PSC-ID and DCC-ID fields are found below the selection filter.\r\n\r\n<u>Option 2:</u> Basic Filter Options\r\nUsers may search for particular candidates by selecting from the \"Basic\" filter options. Users may select from drop-down select boxes, and then click \"Show Data\" to view a list of candidates. If only a fragment of the candidate ID is known, the user may search for the profile by entering the known fragment, and then click show data to find the appropriate profile. For example, searching with \"531\" under \"DCCID\" will retrieve the profile of candidate DCC1107 (with full DCCID 531861).\r\n\r\n<u>Option 3:</u> Advanced Filter Options\r\nMore detailed filter options can be accessed by clicking on the \"Advanced\" button. Users will select from a number of drop-down select boxes including Site, Project, Subproject, Gender etc., and then click \"Show Data\" to view a list of candidates. To return to \"Basic\" selection filters please select \"Basic\".\r\n\r\nTo view a specific candidate’s dataset, click on the candidate’s PSCID found in blue text under the \"PSCID\" column. At the top of the table, column headings will appear underlined and show a click icon when the user hovers over the heading title. Data can be sorted in ascending order according to a given column by clicking on the column heading (i.e. DCCID, Site, PSCID etc.), and by clicking again, in descending order. In both standard and mobile view, the selection filter can be hidden by selecting the upward arrow icon, allowing easier viewing of the data. Once in this view, users can click on the downward arrow icon to display the features of the selection filter once again. This feature applies to all pages that include a Selection Filter.\r\nNote that the form remembers previously selected data such that when the user returns to the \"Access Profile\" page, the selection filter will automatically select profiles according to the last selection settings. Depending on the magnitude of the search, there may be several pages of search results for the user to look through. If \"No candidates found\" appears, this indicates no profiles matched the information specified by the selection filter(s). \r\nWhen on a mobile device or narrow browser window, the table will have a slider at the bottom of the table, facilitating scrolling of the data. The user may also hover or click the arrows that flank the table to see the remainder of the table. When scrolling through search results, the PSC-ID column will freeze and remain displayed on the lefthand side, to allow for easy reference and access to relevant information.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='In many cases, the candidate`s profile will already be created. The Access Profile module, also found under the Candidate menu, allows the user to efficiently search for an existing candidate and access the related data. \r\n\r\nThere are 3 main ways to search for a candidate:\r\n\r\n<u>Option 1:</u> Using PSC-ID and DCC-ID\r\nA specific candidate profile can be accessed directly by entering both the PSC-ID and the DCC-ID in the white boxes to the right of the screen and then clicking the button \"Open Profile\". In a narrow browser window or mobile device the PSC-ID and DCC-ID fields are found below the selection filter.\r\n\r\n<u>Option 2:</u> Basic Filter Options\r\nUsers may search for particular candidates by selecting from the \"Basic\" filter options. Users may select from drop-down select boxes, and then click \"Show Data\" to view a list of candidates. If only a fragment of the candidate ID is known, the user may search for the profile by entering the known fragment, and then click show data to find the appropriate profile. For example, searching with \"531\" under \"DCCID\" will retrieve the profile of candidate DCC1107 (with full DCCID 531861).\r\n\r\n<u>Option 3:</u> Advanced Filter Options\r\nMore detailed filter options can be accessed by clicking on the \"Advanced\" button. Users will select from a number of drop-down select boxes including Site, Project, Subproject, Gender etc., and then click \"Show Data\" to view a list of candidates. To return to \"Basic\" selection filters please select \"Basic\".\r\n\r\nTo view a specific candidate’s dataset, click on the candidate’s PSCID found in blue text under the \"PSCID\" column. At the top of the table, column headings will appear underlined and show a click icon when the user hovers over the heading title. Data can be sorted in ascending order according to a given column by clicking on the column heading (i.e. DCCID, Site, PSCID etc.), and by clicking again, in descending order. In both standard and mobile view, the selection filter can be hidden by selecting the upward arrow icon, allowing easier viewing of the data. Once in this view, users can click on the downward arrow icon to display the features of the selection filter once again. This feature applies to all pages that include a Selection Filter.\r\nNote that the form remembers previously selected data such that when the user returns to the \"Access Profile\" page, the selection filter will automatically select profiles according to the last selection settings. Depending on the magnitude of the search, there may be several pages of search results for the user to look through. If \"No candidates found\" appears, this indicates no profiles matched the information specified by the selection filter(s). \r\nWhen on a mobile device or narrow browser window, the table will have a slider at the bottom of the table, facilitating scrolling of the data. The user may also hover or click the arrows that flank the table to see the remainder of the table. When scrolling through search results, the PSC-ID column will freeze and remain displayed on the lefthand side, to allow for easy reference and access to relevant information.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('timepoint_list'),'Candidate Profile','The database facilitates data collection of longitudinal studies; following the same candidates at various intervals for long periods of time. Each candidate may have several time-points stretching the duration of the study. Each time-point will be given a name called a \"Visit Label\". The time-points refer to data collection on different visits for the same candidate. Every time-point contains a subset of data collected in a given time frame with the intention of keeping this subset in a tightly related group. \r\n\r\nA new candidate time-point can be created from the Candidate Profile page by opening a specific profile and clicking \"Create Time Point\" among the Actions buttons visible above the \"List of Visits\" table. Authorized users may also edit general information about the candidate, such as adding comments and updating participant status, by clicking the \"Edit Candidate Info\" button.\r\n\r\nOnce a candidate’s profile has been opened, the PSC-ID and DCC-ID will remain at the top of the screen in white text on a banner for reference. Clicking on the candidate’s IDs in white will return the user to the Candidate Profile. \r\nBelow the candidate’s information, the user will find a list of time points under \"Visit Label (Click to Open)\". Clicking on the time point itself in navy text can open the profile for the candidate at that time point.\r\n','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The database facilitates data collection of longitudinal studies; following the same candidates at various intervals for long periods of time. Each candidate may have several time-points stretching the duration of the study. Each time-point will be given a name called a \"Visit Label\". The time-points refer to data collection on different visits for the same candidate. Every time-point contains a subset of data collected in a given time frame with the intention of keeping this subset in a tightly related group. \r\n\r\nA new candidate time-point can be created from the Candidate Profile page by opening a specific profile and clicking \"Create Time Point\" among the Actions buttons visible above the \"List of Visits\" table. Authorized users may also edit general information about the candidate, such as adding comments and updating participant status, by clicking the \"Edit Candidate Info\" button.\r\n\r\nOnce a candidate’s profile has been opened, the PSC-ID and DCC-ID will remain at the top of the screen in white text on a banner for reference. Clicking on the candidate’s IDs in white will return the user to the Candidate Profile. \r\nBelow the candidate’s information, the user will find a list of time points under \"Visit Label (Click to Open)\". Clicking on the time point itself in navy text can open the profile for the candidate at that time point.\r\n';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('candidate_parameters'),'Candidate Parameters','The Candidate Parameters Page provides users an opportunity to add important general information about the candidate. There are three sections of the Candidate Parameters Page that can be updated as required by authorized users: \"Candidate Information\", \"Participant Status\", and \"Participation Consent Status\". To return to the Candidate Profile, please click the \"Return to timepoint list\" button.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The Candidate Parameters Page provides users an opportunity to add important general information about the candidate. There are three sections of the Candidate Parameters Page that can be updated as required by authorized users: \"Candidate Information\", \"Participant Status\", and \"Participation Consent Status\". To return to the Candidate Profile, please click the \"Return to timepoint list\" button.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES ((SELECT helpID FROM (SELECT * FROM `help`) as temp WHERE hash=md5('candidate_parameters')),md5('update_candidate_info'),'Update Candidate Information', 'The Update Candidate Information Page allows users to document any additional comments about the candidate that may be important for analysis, as well as external identifiers. Please note the caveat emptor flag is set to \"False\" by default. A candidate with a unique case for data analysis should have the caveat emptor flag marked as \"True\", with a reason for the flag specified through the drop-down option(s) provided, outlining the most common flagged cases for the study at hand, or through the text box field. Additional comments can also be entered. The user must \"Save\" the updates before navigating back to the Candidate Parameters page via the \"Return to Candidate Info\" button.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The Update Candidate Information Page allows users to document any additional comments about the candidate that may be important for analysis, as well as external identifiers. Please note the caveat emptor flag is set to \"False\" by default. A candidate with a unique case for data analysis should have the caveat emptor flag marked as \"True\", with a reason for the flag specified through the drop-down option(s) provided, outlining the most common flagged cases for the study at hand, or through the text box field. Additional comments can also be entered. The user must \"Save\" the updates before navigating back to the Candidate Parameters page via the \"Return to Candidate Info\" button.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES ((SELECT helpID FROM (SELECT * FROM `help`) as temp WHERE hash=md5('candidate_parameters')),md5('update_participant_status'), 'Participant Status', 'All candidates are marked as \"Active\" in the database by default. The participant status can be updated to one of the following options: Active, Refused/Not Enrolled, Ineligible, Excluded, Inactive, Incomplete, Complete.\r\n• Active: Candidate active in the study\r\n• Refused/Not Enrolled: Candidate recruited for the study but opted out\r\n• Ineligible: Candidate met exclusionary criterion/criteria during screening and was never scheduled for a visit\r\n• Excluded: Candidate was enrolled but met exclusionary criterion/criteria after starting the study (e.g. scan was reviewed as exclusionary by radiologist)\r\n• Inactive: Candidate continues to be part of the study but currently is inactive (e.g. Candidate is \"Unsure\" about continuing, \"Requiring further investigation\", or \"Not responding\")\r\n• Incomplete: Candidate has withdrawn.\r\n• Complete: Candidate has completed the study \r\nIf the candidate is listed as Inactive or Incomplete, a reason for the chosen status is required. Additional comments regarding the status can also be entered. The user must \"Save\" the updates before navigating back to the Candidate Parameters page via the button \"Return to Candidate Info\".','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='All candidates are marked as \"Active\" in the database by default. The participant status can be updated to one of the following options: Active, Refused/Not Enrolled, Ineligible, Excluded, Inactive, Incomplete, Complete.\r\n• Active: Candidate active in the study\r\n• Refused/Not Enrolled: Candidate recruited for the study but opted out\r\n• Ineligible: Candidate met exclusionary criterion/criteria during screening and was never scheduled for a visit\r\n• Excluded: Candidate was enrolled but met exclusionary criterion/criteria after starting the study (e.g. scan was reviewed as exclusionary by radiologist)\r\n• Inactive: Candidate continues to be part of the study but currently is inactive (e.g. Candidate is \"Unsure\" about continuing, \"Requiring further investigation\", or \"Not responding\")\r\n• Incomplete: Candidate has withdrawn.\r\n• Complete: Candidate has completed the study \r\nIf the candidate is listed as Inactive or Incomplete, a reason for the chosen status is required. Additional comments regarding the status can also be entered. The user must \"Save\" the updates before navigating back to the Candidate Parameters page via the button \"Return to Candidate Info\".';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES ((SELECT helpID FROM (SELECT * FROM `help`) as temp WHERE hash=md5('candidate_parameters')),md5('update_consent_info'), 'Participation Consent Status', 'Updates can be made on the following participant consent status items:\r\n• Consent to Study: Users may choose from options \"Yes/No\", based on whether written consent was obtained for the study\r\n• Date of Consent to Study: This field is required if Consent to Study=Yes. Users are required to enter the date to consent twice, to minimize error in data entry.\r\n• Date of Withdrawal of Consent to Study: Users are not required to enter anything in this field if the candidate did not retract their consent.\r\nSpecific projects require additional consent for collaborative projects and/or for specific procedures (i.e. consent to draw blood). The same consent status fields apply to any additional consent items pertaining to the study.\r\nPlease note that written consent is required prior to data entry in the database.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='Updates can be made on the following participant consent status items:\r\n• Consent to Study: Users may choose from options \"Yes/No\", based on whether written consent was obtained for the study\r\n• Date of Consent to Study: This field is required if Consent to Study=Yes. Users are required to enter the date to consent twice, to minimize error in data entry.\r\n• Date of Withdrawal of Consent to Study: Users are not required to enter anything in this field if the candidate did not retract their consent.\r\nSpecific projects require additional consent for collaborative projects and/or for specific procedures (i.e. consent to draw blood). The same consent status fields apply to any additional consent items pertaining to the study.\r\nPlease note that written consent is required prior to data entry in the database.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('instrument_list'), 'Time-Point Instrument List','Once inside a time point, the user will see some general information about the candidate across the top of the screen, such as gender, visit label, and subproject. The status of each particular visit can be viewed in the far left panel, where status can be marked as \"Pass\", \"Failure\", \"Withdrawal\", or \"In Progress\". \"Send Time Point\" is selected by the user to \"Send to DCC\", and is the final step in completing data entry for a visit. \r\nThe \"BVL QC Type\" is used to record whether the Behavioural quality control was done on an electronic device or as a hard copy, and the \"BVL QC Status\" records if quality control has been completed. When viewing a visit in a narrow browser window or mobile device, this panel is hidden. The visit panel contains the Actions Menu, the Visit Stage, the Send Time Point, and QC Information. This menu can be opened for viewing or hidden by selecting the list icon at the top lefthand menu. \r\n\r\nEach time point carries a unique set of tests, also known as instruments. In addition to seeing the names of the instruments contained within each behavioural battery, users can view Administration and Data Entry Status, as well as whether any feedback exists for that particular instrument. Information about Double Data Entry progress can also be found within the behavioural battery table.  Click on any instrument name to open the instrument form and perform data entry. Double data entry can be performed by clicking on the \"Double Data Entry\" link for a given instrument.' ,'2014-09-01 00:00:00', NULL)
ON DUPLICATE KEY UPDATE content='Once inside a time point, the user will see some general information about the candidate across the top of the screen, such as gender, visit label, and subproject. The status of each particular visit can be viewed in the far left panel, where status can be marked as \"Pass\", \"Failure\", \"Withdrawal\", or \"In Progress\". \"Send Time Point\" is selected by the user to \"Send to DCC\", and is the final step in completing data entry for a visit. \r\nThe \"BVL QC Type\" is used to record whether the Behavioural quality control was done on an electronic device or as a hard copy, and the \"BVL QC Status\" records if quality control has been completed. When viewing a visit in a narrow browser window or mobile device, this panel is hidden. The visit panel contains the Actions Menu, the Visit Stage, the Send Time Point, and QC Information. This menu can be opened for viewing or hidden by selecting the list icon at the top lefthand menu. \r\n\r\nEach time point carries a unique set of tests, also known as instruments. In addition to seeing the names of the instruments contained within each behavioural battery, users can view Administration and Data Entry Status, as well as whether any feedback exists for that particular instrument. Information about Double Data Entry progress can also be found within the behavioural battery table.  Click on any instrument name to open the instrument form and perform data entry. Double data entry can be performed by clicking on the \"Double Data Entry\" link for a given instrument.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('reliability'), 'Reliability Coding','The Reliability Coding module was designed to allow users across and within sites to be confident in the scoring of data, thus improving the integrity of the data within the database on an on-going basis. This module may not be employed by your study if it does not require inter-rater agreement. Reliability immediately brings forward any discrepancies in instrument administration or data reports, as well as helping reduce human error within data reports. Under the Reliability Coding module, the user can apply the selection filter to narrow down candidates of interest. \r\nA list of entries will appear that organizes candidates by PSCID, the site of reliability, cohort, DCCID, gender, visit label, instrument, reliability score and an indication of whether the chosen candidate has reliable data. Note that certain headings (i.e. DCCID, Site, PSCID etc.) at the top of the table will become underlined and show a click icon when the user hovers over the heading title. These titles can be clicked to sort the table data; clicking more than once will toggle the sort order between ascending and descending order. On a narrow browser window or mobile device, this table has a slider bar at the bottom, as well as arrows flanking the sides for easy scrolling. In this tab, both the selection filter and the \"Swap Candidates\" feature (explained below) can be hidden by selecting the upward arrow icon to the right of the table title and reopened using the downward arrow icon. \r\n\r\nSwap Candidates: The candidates for whom reliability is available are selected at random by the database. However, in the case that a particular candidate lacks adequate data for reliability (e.g. poor quality video), another candidate can be manually selected using the \"Swap Candidates\" feature. Upon clicking the \"Swap Candidates\" button next to the Selection Filter, users can input the information of the \"Original Candidate\" with insufficient data for reliability, and input a desired \"Replacement Candidate\". The user can indicate the instrument in question and proceed to clicking \"Swap Candidates\". \r\n\r\nOnce the user has completed a search within the Reliability Module, the user can click on the PSCID of the candidate for the instrument in question. The \"Reliable\" column shows the user whether the reliability score surpasses the established threshold for reliability by being marked as \"Yes\" in green if the candidate is reliable or \"No\" in red if the candidate did not pass reliability. If the candidate had been flagged as invalid, the user will see a note in red text beside the PSCID.\r\n \r\nFor each instrument configured under the module, the user will see a table listing the reliability status of each rater (e.g. \"Yes\" or \"In progress\"), as well as the date at which reliability was established, date at which the tape was sent, date at which Feedback was received, whether the rater is outside the research group and Administration status (e.g., \"Current\" or \"No\"). The criteria required for a candidate to be considered reliable is outlined below the heading of each instrument.\r\n\r\n<b>Entering Reliability Data</b>\r\nAfter clicking on a PSCID, a data entry screen will appear for second raters to enter data for the selected candidate and time point. The database will automatically compare the newly entered data to that entered by the first rater and calculate a reliability score. This score can then be viewed on the main reliability page under the \"Reliability Score\" Column.\r\n\r\n<b>After saving Reliability form</b>\r\nThis page displays all data that was previously entered in the reliability form. These are static and cannot be altered from this page. Users can directly access the initial data entry form through the Comment ID link in blue text under \"Scoring\". Please use the Clinical Menu to navigate back to the Reliability Coding page.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The Reliability Coding module was designed to allow users across and within sites to be confident in the scoring of data, thus improving the integrity of the data within the database on an on-going basis. This module may not be employed by your study if it does not require inter-rater agreement. Reliability immediately brings forwnard any discrepancies in instrument administration or data reports, as well as helping reduce human error within data reports. Under the Reliability Coding module, the user can apply the selection filter to narrow down candidates of interest. \r\nA list of entries will appear that organizes candidates by PSCID, the site of reliability, cohort, DCCID, gender, visit label, instrument, reliability score and an indication of whether the chosen candidate has reliable data. Note that certain headings (i.e. DCCID, Site, PSCID etc.) at the top of the table will become underlined and show a click icon when the user hovers over the heading title. These titles can be clicked to sort the table data; clicking more than once will toggle the sort order between ascending and descending order. On a narrow browser window or mobile device, this table has a slider bar at the bottom, as well as arrows flanking the sides for easy scrolling. In this tab, both the selection filter and the \"Swap Candidates\" feature (explained below) can be hidden by selecting the upward arrow icon to the right of the table title and reopened using the downward arrow icon. \r\n\r\nSwap Candidates: The candidates for whom reliability is available are selected at random by the database. However, in the case that a particular candidate lacks adequate data for reliability (e.g. poor quality video), another candidate can be manually selected using the \"Swap Candidates\" feature. Upon clicking the \"Swap Candidates\" button next to the Selection Filter, users can input the information of the \"Original Candidate\" with insufficient data for reliability, and input a desired \"Replacement Candidate\". The user can indicate the instrument in question and proceed to clicking \"Swap Candidates\". \r\n\r\nOnce the user has completed a search within the Reliability Module, the user can click on the PSCID of the candidate for the instrument in question. The \"Reliable\" column shows the user whether the reliability score surpasses the established threshold for reliability by being marked as \"Yes\" in green if the candidate is reliable or \"No\" in red if the candidate did not pass reliability. If the candidate had been flagged as invalid, the user will see a note in red text beside the PSCID.\r\n \r\nFor each instrument configured under the module, the user will see a table listing the reliability status of each rater (e.g. \"Yes\" or \"In progress\"), as well as the date at which reliability was established, date at which the tape was sent, date at which Feedback was received, whether the rater is outside the research group and Administration status (e.g., \"Current\" or \"No\"). The criteria required for a candidate to be considered reliable is outlined below the heading of each instrument.\r\n\r\n<b>Entering Reliability Data</b>\r\nAfter clicking on a PSCID, a data entry screen will appear for second raters to enter data for the selected candidate and time point. The database will automatically compare the newly entered data to that entered by the first rater and calculate a reliability score. This score can then be viewed on the main reliability page under the \"Reliability Score\" Column.\r\n\r\n<b>After saving Reliability form</b>\r\nThis page displays all data that was previously entered in the reliability form. These are static and cannot be altered from this page. Users can directly access the initial data entry form through the Comment ID link in blue text under \"Scoring\". Please use the Clinical Menu to navigate back to the Reliability Coding page.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('conflict_resolver'), 'Conflict Resolver','The Conflict Resolver tool allows users to view and keep track of any discrepancies that may arise between initial data entry and double data entry forms. Unresolved and Resolved conflicts are found on two separate tabs of the module. The Unresolved conflicts are displayed first upon accessing the Conflict Resolver module. The Conflict Resolver has a selection filter function to allow users to search for a particular subject and/or instrument. By clicking the button \"Show Data\" after selecting certain search options, the search results will be updated to reflect the selection filter criteria. The search results table is organized by the blue headers \"Instrument\", \"DCCID\", \"PSCID\", \"Visit Label\", \"Question\", and \"Correct Answer\". \r\nIf the user is confident that the data for the particular question of interest is consistent across the two data entry forms, the user can select the appropriate answer from the drop-down menu under the \"Correct Answer\" column and then click \"Save\" at the bottom of the table to resolve the issue. After refreshing the page, this newly resolved conflict will no longer appear under the Unresolved Conflicts tab, and will appear among the list of resolved conflicts on the second tab of the module. Similar to other pages of the database, the selection filter can be hidden by selecting upward arrow icon and reopened using the downward arrow icon.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The Conflict Resolver tool allows users to view and keep track of any discrepancies that may arise between initial data entry and double data entry forms. Unresolved and Resolved conflicts are found on two separate tabs of the module. The Unresolved conflicts are displayed first upon accessing the Conflict Resolver module. The Conflict Resolver has a selection filter function to allow users to search for a particular subject and/or instrument. By clicking the button \"Show Data\" after selecting certain search options, the search results will be updated to reflect the selection filter criteria. The search results table is organized by the blue headers \"Instrument\", \"DCCID\", \"PSCID\", \"Visit Label\", \"Question\", and \"Correct Answer\". \r\nIf the user is confident that the data for the particular question of interest is consistent across the two data entry forms, the user can select the appropriate answer from the drop-down menu under the \"Correct Answer\" column and then click \"Save\" at the bottom of the table to resolve the issue. After refreshing the page, this newly resolved conflict will no longer appear under the Unresolved Conflicts tab, and will appear among the list of resolved conflicts on the second tab of the module. Similar to other pages of the database, the selection filter can be hidden by selecting upward arrow icon and reopened using the downward arrow icon.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('certification'), 'Certification','The Certification module allows the user to access and input information regarding examiners’ credentials. To view existing credentials, the user must select the examiner’s name outlined in navy text. \r\nThe Certification module also has a selection filter to allow users to search for a particular examiner or measure. The user may also create new credentials first by clicking \"Add Certification\". Similar to other pages of the database, the selection filter can be hidden by selecting upward arrow icon and reopened using the downward arrow icon.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The Certification module allows the user to access and input information regarding examiners’ credentials. To view existing credentials, the user must select the examiner’s name outlined in navy text. \r\nThe Certification module also has a selection filter to allow users to search for a particular examiner or measure. The user may also create new credentials first by clicking \"Add Certification\". Similar to other pages of the database, the selection filter can be hidden by selecting upward arrow icon and reopened using the downward arrow icon.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES ((SELECT helpID FROM (SELECT * FROM `help`) as temp WHERE hash=md5('certification')),md5('edit_event'), 'Add Certification','To add certification, the user must select an examiner from the drop down menu. The status of his/her training for various instruments must be selected as \"Not Certified\", \"In Training\" or \"Certified\" and the date that the certification has been updated must be input. In order to store changes in certification the user must click \"Save\" after updating the examiner’s information. Note that certification updates for each examiner are recorded in a \"Change Log\", just below the \"Edit Certification Event\" box.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='To add certification, the user must select an examiner from the drop down menu. The status of his/her training for various instruments must be selected as \"Not Certified\", \"In Training\" or \"Certified\" and the date that the certification has been updated must be input. In order to store changes in certification the user must click \"Save\" after updating the examiner’s information. Note that certification updates for each examiner are recorded in a \"Change Log\", just below the \"Edit Certification Event\" box.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('document_repository'), 'Document Repository', 'The Document Repository is a useful tool that provides multiple users with a centralized location for important documents relevant to the project. Files may be uploaded and organized under any user-defined category. Subcategories can also be defined by the user to be nested under parent categories. To view the previously uploaded files, the user must click on the appropriate category title to reveal a complete list of subcategories, and subsequently its files. Clicking on the file name outlined in blue will open these files. Various metadata at the file level may also be edited by selecting the corresponding \"Edit\" link and files can be deleted with the \"Delete\" link to the right of the desired file. Categories and uploaded files can have comments attached to them to provide additional information. To edit the comments of a specific category, hover over the ellipsis beside the title and click the text to make any necessary changes.\r\n\r\nSimilar to other modules in the LORIS database, the Document Repository has a Selection Filter with which the user may input search criteria, and select \"Show Data\" to locate specific documents. Clicking on the column headers serves to sort the data, consistent with other pages of the LORIS database. Clicking \"Upload File\" in the Selection Filter window enables the user to upload new and/or revised documents. Clicking \"Add Category\" allows a user to create a new category or subcategory to an existing parent category.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The Document Repository is a useful tool that provides multiple users with a centralized location for important documents relevant to the project. Files may be uploaded and organized under any user-defined category. Subcategories can also be defined by the user to be nested under parent categories. To view the previously uploaded files, the user must click on the appropriate category title to reveal a complete list of subcategories, and subsequently its files. Clicking on the file name outlined in blue will open these files. Various metadata at the file level may also be edited by selecting the corresponding \"Edit\" link and files can be deleted with the \"Delete\" link to the right of the desired file. Categories and uploaded files can have comments attached to them to provide additional information. To edit the comments of a specific category, hover over the ellipsis beside the title and click the text to make any necessary changes.\r\n\r\nSimilar to other modules in the LORIS database, the Document Repository has a Selection Filter with which the user may input search criteria, and select \"Show Data\" to locate specific documents. Clicking on the column headers serves to sort the data, consistent with other pages of the LORIS database. Clicking \"Upload File\" in the Selection Filter window enables the user to upload new and/or revised documents. Clicking \"Add Category\" allows a user to create a new category or subcategory to an existing parent category.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('final_radiological_review'), 'Radiological Review','The user can view the radiological review status for each candidate and corresponding visit label through the Radiological Review module.\r\n\r\n<b>To Access Reviews:</b>\r\nSet appropriate filters in the Selection Filter box and click the \"Show Data\" button to retrieve a list of the search results. The results are categorized by column by the candidate’s IDs, date of birth, visit label, review completion status, results (e.g., normal, atypical), exclusionary status and custom fields such as subarachnoid spaces (SAS) status (e.g., none, mild, minimal), perivascular spaces (PVS) and any further comments. This filter can be hidden by selecting the upward arrow icon and reopened using the downward arrow icon. In a narrow browser window or mobile device the table of search results will be displayed below the selection filter. \r\nIn the data table there is a column addressing whether any conflict exists between final and extra reviews, which can be found under the blue heading \"Conflict\". Next to this column, the user will find whether the review was finalized. The user will see that hovering over each of the blue headings displays a click icon; if selected, the columns will sort in ascending or descending order. Note that clicking several times will reverse/change the sorting pattern. In addition, the table will fit to the browser size, and display a slide bar at the bottom as well as arrows flanking the table to ease data viewing. By clicking on a PSCID, the candidate’s file will be opened and the user can access the radiological review. \r\n<b>Within a Radiological Review</b> \r\nIf a conflict exists between the original and final review, a warning will appear at the top of the screen in red text. General Information, such as PSCID, DCCID, Visit Label, and DICOM folder can be easily viewed from the Final Radiological Review page. The user can directly access this candidate’s Imaging Browser page or Final Radiological Review by following the links next to \"Go to:\" under the General Information section. Details of the candidate’s radiological review at that particular time-point can be viewed in the box under the navy blue heading \"Review Values\". Any changes made to the record will be documented in the table following the heading \"Change Log\".','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The user can view the radiological review status for each candidate and corresponding visit label through the Radiological Review module.\r\n\r\n<b>To Access Reviews:</b>\r\nSet appropriate filters in the Selection Filter box and click the \"Show Data\" button to retrieve a list of the search results. The results are categorized by column by the candidate’s IDs, date of birth, visit label, review completion status, results (e.g., normal, atypical), exclusionary status and custom fields such as subarachnoid spaces (SAS) status (e.g., none, mild, minimal), perivascular spaces (PVS) and any further comments. This filter can be hidden by selecting the upward arrow icon and reopened using the downward arrow icon. In a narrow browser window or mobile device the table of search results will be displayed below the selection filter. \r\nIn the data table there is a column addressing whether any conflict exists between final and extra reviews, which can be found under the blue heading \"Conflict\". Next to this column, the user will find whether the review was finalized. The user will see that hovering over each of the blue headings displays a click icon; if selected, the columns will sort in ascending or descending order. Note that clicking several times will reverse/change the sorting pattern. In addition, the table will fit to the browser size, and display a slide bar at the bottom as well as arrows flanking the table to ease data viewing. By clicking on a PSCID, the candidate’s file will be opened and the user can access the radiological review. \r\n<b>Within a Radiological Review</b> \r\nIf a conflict exists between the original and final review, a warning will appear at the top of the screen in red text. General Information, such as PSCID, DCCID, Visit Label, and DICOM folder can be easily viewed from the Final Radiological Review page. The user can directly access this candidate’s Imaging Browser page or Final Radiological Review by following the links next to \"Go to:\" under the General Information section. Details of the candidate’s radiological review at that particular time-point can be viewed in the box under the navy blue heading \"Review Values\". Any changes made to the record will be documented in the table following the heading \"Change Log\".';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('dicom_archive'),'Dicom Archive','The user can access all DICOM files through the DICOM Archive under the \"Imaging\" menu. By default, all fields in the Selection Filter will appear to be null and no search results will be listed. Users can click \"Submit\" to view all imaging data. A more detailed search can be executed using selected fields from the Selection Filter. This includes filtering by \"Patient ID\", \"Patient Name\", \"Gender\", \"Date of Birth\", \"Acquisition\" date, and/or \"Archive Location\". This Selection Filter can be hidden using the upward arrow icon and re-opened by selecting the downward arrow icon. After submitting a search, the user will be able to see how many results their search has retrieved. The user can organize the results in ascending or descending order by clicking on any of the blue headers of the table, consistent with other pages on the LORIS database.\r\n\r\nLinks to a particular patient’s DICOM archive can be accessed through the Metadata column by clicking \"View Details\". Direct links to neuroimaging data can also be accessed through the Imaging Browser column.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The user can access all DICOM files through the DICOM Archive under the \"Imaging\" menu. By default, all fields in the Selection Filter will appear to be null and no search results will be listed. Users can click \"Submit\" to view all imaging data. A more detailed search can be executed using selected fields from the Selection Filter. This includes filtering by \"Patient ID\", \"Patient Name\", \"Gender\", \"Date of Birth\", \"Acquisition\" date, and/or \"Archive Location\". This Selection Filter can be hidden using the upward arrow icon and re-opened by selecting the downward arrow icon. After submitting a search, the user will be able to see how many results their search has retrieved. The user can organize the results in ascending or descending order by clicking on any of the blue headers of the table, consistent with other pages on the LORIS database.\r\n\r\nLinks to a particular patient’s DICOM archive can be accessed through the Metadata column by clicking \"View Details\". Direct links to neuroimaging data can also be accessed through the Imaging Browser column.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES ((SELECT helpID FROM (SELECT * FROM `help`) as temp WHERE hash=md5('dicom_archive')),md5('viewDetails'),'Dicom Archive - View Details','Within a particular candidate’s DICOM archive, specific information about the patient can be found, as well as details about imaging data acquisition. Specifics of the DICOM Series can be found in the table, located near the bottom of the DICOM archive page, and can provide information as to whether there was a protocol violation.Under the specifics of the Series, two links to \"Show/Hide files\" and \"Show/Hide metadata\" can be clicked to expand the table and reveal additional information. \r\n\r\nNote the DICOM archive for a particular candidate can also be accessed directly from their corresponding Imaging Browser page.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content=,'Within a particular candidate’s DICOM archive, specific information about the patient can be found, as well as details about imaging data acquisition. Specifics of the DICOM Series can be found in the table, located near the bottom of the DICOM archive page, and can provide information as to whether there was a protocol violation.Under the specifics of the Series, two links to \"Show/Hide files\" and \"Show/Hide metadata\" can be clicked to expand the table and reveal additional information. \r\n\r\nNote the DICOM archive for a particular candidate can also be accessed directly from their corresponding Imaging Browser page.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('imaging_browser'),'Imaging Browser ','By default, all fields in the Selection Filter will appear to be null and no search results will be listed. Users can click \"Submit\" to view all imaging data. A more detailed search can be executed using selected fields from the Selection Filter. After submitting a search, the Imaging browser will organize the results by time-point and the user will be able to see how many results their search has retrieved. \r\nThe user can organize the results in ascending or descending order by clicking on any of the blue headers of the table. The date of first acquisition for the imaging dataset is indicated under \"First Acq Date\" column. The date on which the data was last QC\’ed can be found under \"Last QC\". Any data that was recently inserted will be indicated via the label \"NEW\" under \"New Data\". \r\n\r\nTo view the imaging datasets for a specific candidate\'s timepoint, select a dataset type from under the 3 \"Links\" columns: \"native\", \"selected\", and \"all types\". \"Native\" will show only raw imaging datasets, \"Selected\" displays only scans on which QC has flagged as optimal, and \"all types\" displays all data, including analyzed outputs. By clicking on any of these links, the user will be able to see details for that specific subject\’s dataset from a given scanning session. \r\n\r\nNote that the Imaging Browser may also be accessed from the DICOM Archive module.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='By default, all fields in the Selection Filter will appear to be null and no search results will be listed. Users can click \"Submit\" to view all imaging data. A more detailed search can be executed using selected fields from the Selection Filter. After submitting a search, the Imaging browser will organize the results by time-point and the user will be able to see how many results their search has retrieved. \r\nThe user can organize the results in ascending or descending order by clicking on any of the blue headers of the table. The date of first acquisition for the imaging dataset is indicated under \"First Acq Date\" column. The date on which the data was last QC\’ed can be found under \"Last QC\". Any data that was recently inserted will be indicated via the label \"NEW\" under \"New Data\". \r\n\r\nTo view the imaging datasets for a specific candidate\'s timepoint, select a dataset type from under the 3 \"Links\" columns: \"native\", \"selected\", and \"all types\". \"Native\" will show only raw imaging datasets, \"Selected\" displays only scans on which QC has flagged as optimal, and \"all types\" displays all data, including analyzed outputs. By clicking on any of these links, the user will be able to see details for that specific subject\’s dataset from a given scanning session. \r\n\r\nNote that the Imaging Browser may also be accessed from the DICOM Archive module.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES ((SELECT helpID FROM (SELECT * FROM `help`) as temp WHERE hash=md5('imaging_browser')),md5('viewSession'),'Imaging Browser: View Session','At the top of the page is a box with grey headings, listing general information about the candidate, including subject IDs, demographic information, key parameters (e.g. scannerID) and QC status. \r\n\r\nIn the left side panel, QC status flags can be set at the bottom under \"Visit QC\", and detailed QC information can be entered for the entire timepoint dataset via \"Visit-level feedback\", under \"Visit Controls\". Clicking on \"Visit-level feedback\" will open a new window with the candidate’s information (e.g.CandID, PSCID, Visit Label and Subproject ID), as well as any additional QC comments and/or existing Mantis bug reports.\r\n\r\nThe files for the selected candidate’s dataset are displayed below the general information box. Horizontal, sagittal and coronal views of each scan volume are grouped together. Each set of images for each file also has a list of scan parameters listed on the right, including protocol, the date at which the image was acquired, the date the images were put on the database, and other details regarding scan acquisition. \r\n\r\nTo the left of the images, there is a panel displaying the QC status of the scan, and if any \"caveat emptor\" flags exist. If a specific acquisition has been \"selected\" as the optimal scan of its type or modality (e.g. t1) for this dataset, the modality will be displayed as the selected option in the \"Selected\" dropdown box found within the left-hand panel of each scan. Detailed QC information about a specific scan can be entered by clicking \"Link to comments\", which will open a separate smaller window with a summary of the candidate’s information and the filename, followed by comments, if any exist, regarding intensity, movement artifacts, coverage and overall feedback on the selected scan. After saving any changes, the user can either close the pop-up window or use the link at the top: \"Click here to close this window\".\r\n\r\n<b>Visualization</b>\r\nTo use visualization tools BrainBrowser and the JIV viewer. The user can also access 3D images through the navy blue links \"3D+Overlay\" and \"3D Only\" for both the JIV Panel and BrainBrowser in the left sidebar. \r\n\r\nIn the left sidebar, Links are also displayed to direct the user to the MRI parameter form, Radiological Review, DICOM Archive module, and Mantis issue-tracking tool. \r\nAt the top of the left sidebar, the user can click on \"Next\" to move to the next time-point for the candidate of interest.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='At the top of the page is a box with grey headings, listing general information about the candidate, including subject IDs, demographic information, key parameters (e.g. scannerID) and QC status. \r\n\r\nIn the left side panel, QC status flags can be set at the bottom under \"Visit QC\", and detailed QC information can be entered for the entire timepoint dataset via \"Visit-level feedback\", under \"Visit Controls\". Clicking on \"Visit-level feedback\" will open a new window with the candidate’s information (e.g.CandID, PSCID, Visit Label and Subproject ID), as well as any additional QC comments and/or existing Mantis bug reports.\r\n\r\nThe files for the selected candidate’s dataset are displayed below the general information box. Horizontal, sagittal and coronal views of each scan volume are grouped together. Each set of images for each file also has a list of scan parameters listed on the right, including protocol, the date at which the image was acquired, the date the images were put on the database, and other details regarding scan acquisition. \r\n\r\nTo the left of the images, there is a panel displaying the QC status of the scan, and if any \"caveat emptor\" flags exist. If a specific acquisition has been \"selected\" as the optimal scan of its type or modality (e.g. t1) for this dataset, the modality will be displayed as the selected option in the \"Selected\" dropdown box found within the left-hand panel of each scan. Detailed QC information about a specific scan can be entered by clicking \"Link to comments\", which will open a separate smaller window with a summary of the candidate’s information and the filename, followed by comments, if any exist, regarding intensity, movement artifacts, coverage and overall feedback on the selected scan. After saving any changes, the user can either close the pop-up window or use the link at the top: \"Click here to close this window\".\r\n\r\n<b>Visualization</b>\r\nTo use visualization tools BrainBrowser and the JIV viewer. The user can also access 3D images through the navy blue links \"3D+Overlay\" and \"3D Only\" for both the JIV Panel and BrainBrowser in the left sidebar. \r\n\r\nIn the left sidebar, Links are also displayed to direct the user to the MRI parameter form, Radiological Review, DICOM Archive module, and Mantis issue-tracking tool. \r\nAt the top of the left sidebar, the user can click on \"Next\" to move to the next time-point for the candidate of interest.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('imaging_uploader'), 'Imaging Uploader', 'The Imaging Uploader allows users to upload imaging files, typically for an entire imaging session at a time. Please note that files should be in a compressed format (.tgz, .tar.gz, or .zip) and must be labeled properly in order to be uploaded successfully into the database. \r\n\r\nAfter choosing the file to upload, users must input the CandID, PSCID, and Visit Label for this dataset, and then click the \"Upload\" button. The newly uploaded file will be displayed in the table at the bottom of the page. \r\n\r\nUsers can also use the topmost panel to search for datasets uploaded in the past, y leaving the \"File to Upload\" field blank, and filling any of the remaining fields such as an ID or visit label, then clicking \"Show Data\". Results will be displayed in the table at bottom, which can be sorted by columns \"CandID\", \"Visit Label\", \"Source Location\", \"Upload Date\" and \"Uploaded By\", as well as by number of Minc files inserted, and number of Minc files created.\r\n\r\nNote that the \"Tarchive Info\" column contains links to the corresponding DICOM header information for a given imaging dataset, via the DICOM Archive module. Also, to display the current status in the \"Progress\" column of the uploads table at bottom, you should refresh the page.\r\n\r\nTo view the output of the imaging insertion pipeline for a given uploaded file by selecting its row in the table of uploads at bottom. When you click on a row in the imaging upload table, the panel called \"Upload Process Logs\" (above the table of uploads) will display the most recent output of the imaging insertion pipeline for that particular file. This display will be refreshed every five seconds. There are two modes for displaying logs: \"Detailed\", which retrieves everything output by the pipeline and \"Summary\" which displays only the most important log messages (namely the steps successfully executed by the pipeline).','2016-04-29 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The Imaging Uploader allows users to upload imaging files, typically for an entire imaging session at a time. Please note that files should be in a compressed format (.tgz, .tar.gz, or .zip) and must be labeled properly in order to be uploaded successfully into the database. \r\n\r\nAfter choosing the file to upload, users must input the CandID, PSCID, and Visit Label for this dataset, and then click the \"Upload\" button. The newly uploaded file will be displayed in the table at the bottom of the page. \r\n\r\nUsers can also use the topmost panel to search for datasets uploaded in the past, y leaving the \"File to Upload\" field blank, and filling any of the remaining fields such as an ID or visit label, then clicking \"Show Data\". Results will be displayed in the table at bottom, which can be sorted by columns \"CandID\", \"Visit Label\", \"Source Location\", \"Upload Date\" and \"Uploaded By\", as well as by number of Minc files inserted, and number of Minc files created.\r\n\r\nNote that the \"Tarchive Info\" column contains links to the corresponding DICOM header information for a given imaging dataset, via the DICOM Archive module. Also, to display the current status in the \"Progress\" column of the uploads table at bottom, you should refresh the page.\r\n\r\nTo view the output of the imaging insertion pipeline for a given uploaded file by selecting its row in the table of uploads at bottom. When you click on a row in the imaging upload table, the panel called \"Upload Process Logs\" (above the table of uploads) will display the most recent output of the imaging insertion pipeline for that particular file. This display will be refreshed every five seconds. There are two modes for displaying logs: \"Detailed\", which retrieves everything output by the pipeline and \"Summary\" which displays only the most important log messages (namely the steps successfully executed by the pipeline).';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('statistics'), 'Database Statistics', 'The Database statistics module calculates and displays statistics related to data acquisition, data processing, and data entry for both behavioural and imaging data collections. A brief description of \"Demographic\", \"Imaging\", and \"Behavioural Statistics\" can be found under the \"General Description\" tab. In addition to these tabs, the user can also view \"Reliability Statistics\". These statistics categories will condense into a drop-down menu in a narrow browser view or mobile device, but can be opened using the downward arrow icon and hidden using the upward arrow icon.\r\n\r\n<b>Demographic Statistics</b>\r\nGeneral statistics can be retrieved from each site by using the drop-down select box under the first smaller heading \"General Statistics\" and clicking on the button \"Submit Query\". Under General Statistics, the user will find the heading \"Breakdown of Registered Candidates\", where a table outlines gender breakdowns per site, time-point and subproject ID. Data Entry Completion Status can be viewed for each instrument by selecting from the dropdown menu under \"Breakdown of Registered Candidates\". Click \"Submit Query\" to view statistics specific to the selected instrument. \r\n\r\n<b>Behavioural Statistics</b>\r\nThe user will first see a table labeled \"Data Entry Statistics\", where each site is listed in blue headers horizontally and includes the headings \"Completed\", \"Created\", and \"% Completion\". \"Completed\" refers to the total number of instruments that have been marked \"Data Entry= Complete\" and \"Administration= None/Partial/All\". This column has its percentage counterpart under \"% Completion\". \"Created\" refers to the total number of instruments that have been populated requiring data entry. Another feature allows all site information to be reversibly hidden except \"% Completion\" by a single click on the Site Name (i.e. AAA, DCC etc.). The \"Double Data Entry Statistics\" table underneath rests on a similar premise as the \"Data Entry Statistics\" Table, but with regards to double data entry. In both of these tables, the visits are listed in rows with the data sorted by site. Depending on the study and number of sites involved, the user will need to navigate horizontally through the table using the slider or the arrows flanking the table. When using a desktop the user must hover the mouse over the arrows, whereas on a mobile device the user must click on the arrows. The user also has the option of viewing \"Per Instrument Stats\" at the bottom of each site’s column, by following the \"Please Click Here\" link. The user can then view which candidates have not completed data entry in each site. \r\n\r\n<b>Reliability Statistics</b>\r\nThe Reliability Statistics module currently sorts each instrument by visit label and shows the number of flagged, completed, and reliable cases, in addition to expressing reliability and completion in terms of percentages. \"Total Flagged\" cases refer to the number of candidates with levels consistently falling below a given threshold, thus they have been ‘flagged’ for reliability review. The \"Total Complete\" column contains the number of candidates for whom a reliability review has been completed. The \"Total Reliable\" column adds to the information in \"Total Complete\", but includes only those candidates whose information is now reliable. The Reliability Statistics Table also includes \"Percent Complete\" and \"Percent Reliable\" columns. Under the smaller navy heading \"Reliability Statistics\", the user can search for specific statistics for their site of interest by using the dropdown menu and clicking the button \"Submit Query\".\r\n\r\n<b>Imaging Statistics</b>\r\nThe first table under \"Imaging Integrity Statistics for\" displays information regarding missing imaging data, as indicated by data entry on the MRI parameter form, and scan insertions based on records in the Imaging Browser and DICOM archive. Specific candidates with missing imaging data can be easily identified through the link \"Click here for breakdown per participant\" under the \"Breakdown of Problems\" column.\r\n\r\nThe second table within the Imaging Statistics module allows the user to get a breakdown of statistics for candidates by time-point, based on the scan selected. Depending on the project, the user can choose from T1, T2, T1 & T2, DTI, BOLD, and Spectroscopy scans, and other possible options at the top left of the second table, to show the relative number of candidates with scans marked as \"Complete\", \"Partial\", or \"No Scan\". Under the column \"% Complete\", the user can view the percentage of candidates for the scan of interest that have completed scans. The record of scans has the subprojects listed across the top of the table horizontally, with each site encompassing all of its time points listed in rows. A breakdown of the total imaging data is also available at the bottom of the table.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The Database statistics module calculates and displays statistics related to data acquisition, data processing, and data entry for both behavioural and imaging data collections. A brief description of \"Demographic\", \"Imaging\", and \"Behavioural Statistics\" can be found under the \"General Description\" tab. In addition to these tabs, the user can also view \"Reliability Statistics\". These statistics categories will condense into a drop-down menu in a narrow browser view or mobile device, but can be opened using the downward arrow icon and hidden using the upward arrow icon.\r\n\r\n<b>Demographic Statistics</b>\r\nGeneral statistics can be retrieved from each site by using the drop-down select box under the first smaller heading \"General Statistics\" and clicking on the button \"Submit Query\". Under General Statistics, the user will find the heading \"Breakdown of Registered Candidates\", where a table outlines gender breakdowns per site, time-point and subproject ID. Data Entry Completion Status can be viewed for each instrument by selecting from the dropdown menu under \"Breakdown of Registered Candidates\". Click \"Submit Query\" to view statistics specific to the selected instrument. \r\n\r\n<b>Behavioural Statistics</b>\r\nThe user will first see a table labeled \"Data Entry Statistics\", where each site is listed in blue headers horizontally and includes the headings \"Completed\", \"Created\", and \"% Completion\". \"Completed\" refers to the total number of instruments that have been marked \"Data Entry= Complete\" and \"Administration= None/Partial/All\". This column has its percentage counterpart under \"% Completion\". \"Created\" refers to the total number of instruments that have been populated requiring data entry. Another feature allows all site information to be reversibly hidden except \"% Completion\" by a single click on the Site Name (i.e. AAA, DCC etc.). The \"Double Data Entry Statistics\" table underneath rests on a similar premise as the \"Data Entry Statistics\" Table, but with regards to double data entry. In both of these tables, the visits are listed in rows with the data sorted by site. Depending on the study and number of sites involved, the user will need to navigate horizontally through the table using the slider or the arrows flanking the table. When using a desktop the user must hover the mouse over the arrows, whereas on a mobile device the user must click on the arrows. The user also has the option of viewing \"Per Instrument Stats\" at the bottom of each site’s column, by following the \"Please Click Here\" link. The user can then view which candidates have not completed data entry in each site. \r\n\r\n<b>Reliability Statistics</b>\r\nThe Reliability Statistics module currently sorts each instrument by visit label and shows the number of flagged, completed, and reliable cases, in addition to expressing reliability and completion in terms of percentages. \"Total Flagged\" cases refer to the number of candidates with levels consistently falling below a given threshold, thus they have been ‘flagged’ for reliability review. The \"Total Complete\" column contains the number of candidates for whom a reliability review has been completed. The \"Total Reliable\" column adds to the information in \"Total Complete\", but includes only those candidates whose information is now reliable. The Reliability Statistics Table also includes \"Percent Complete\" and \"Percent Reliable\" columns. Under the smaller navy heading \"Reliability Statistics\", the user can search for specific statistics for their site of interest by using the dropdown menu and clicking the button \"Submit Query\".\r\n\r\n<b>Imaging Statistics</b>\r\nThe first table under \"Imaging Integrity Statistics for\" displays information regarding missing imaging data, as indicated by data entry on the MRI parameter form, and scan insertions based on records in the Imaging Browser and DICOM archive. Specific candidates with missing imaging data can be easily identified through the link \"Click here for breakdown per participant\" under the \"Breakdown of Problems\" column.\r\n\r\nThe second table within the Imaging Statistics module allows the user to get a breakdown of statistics for candidates by time-point, based on the scan selected. Depending on the project, the user can choose from T1, T2, T1 & T2, DTI, BOLD, and Spectroscopy scans, and other possible options at the top left of the second table, to show the relative number of candidates with scans marked as \"Complete\", \"Partial\", or \"No Scan\". Under the column \"% Complete\", the user can view the percentage of candidates for the scan of interest that have completed scans. The record of scans has the subprojects listed across the top of the table horizontally, with each site encompassing all of its time points listed in rows. A breakdown of the total imaging data is also available at the bottom of the table.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES ((SELECT helpID FROM (SELECT * FROM `help`) as temp WHERE hash=md5('statistics')),md5('statistics_site'), 'Per Instrument Statistics', 'Completion Statistics for each site are displayed, and are organized by instrument and visit label. The \"Completion Count\" column displays the number of completed entries per instrument. Each PSCID that appears in the \"Incomplete Candidates\" list was designed to be a link itself to that particular candidate’s page for the selected instrument.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='Completion Statistics for each site are displayed, and are organized by instrument and visit label. The \"Completion Count\" column displays the number of completed entries per instrument. Each PSCID that appears in the \"Incomplete Candidates\" list was designed to be a link itself to that particular candidate’s page for the selected instrument.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES ((SELECT helpID FROM (SELECT * FROM `help`) as temp WHERE hash=md5('statistics')),md5('statistics_mri_site'), 'Imaging Integrity Statistics Breakdown', 'This page contains a table listing various Scan Insertion Issues in the left-most column. In the \"Incomplete Entries\" column, clicking on the candidate IDs will redirect the user to the appropriate Imaging form or dataset for that candidate.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='This page contains a table listing various Scan Insertion Issues in the left-most column. In the \"Incomplete Entries\" column, clicking on the candidate IDs will redirect the user to the appropriate Imaging form or dataset for that candidate.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('datadict'), 'Data Dictionary', 'As the title suggests, the Data Dictionary houses definitions or descriptions for various instrument fields. In addition, like many other modules in LORIS, the Data Dictionary features a Selection Filter where the user may select from a number of drop-down select boxes and click \"Show Data\" to quickly locate desired information. The selection filter can be hidden using the upward arrow icon, and reopened using the downward arrow icon.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The Data Team Helper allows the users to find out what the outstanding behaviourial feedbacks, conflicts and incomplete forms for the given candidate/field/instrument by filtering for the given visit-Label and Instrument. This module will also display the \"Single Data_entry Completion Percentage\" for the given visit and instrument, only if the instrument is selected.\n\r The resulting table:\n - displays all fields from the selected instrument (or All Instruments if this feature was chosen) for the specified visit. \n - Under the column \"Names (Instrument_Fieldname)\", the given field name is clickable which allows the user to download the data for the given field/instrument in the .csv format, containing the data and data_entry (i.e complete, in_progress or null)  for every candidate for the given field and visit.\n- The \"Link to Bvl Feedback\" column contains links to pop-up feedback window, where feedback for a particular field and candidate was previously entered, based on the field-name. If such information was never entered, users will see \"N/A\". \n- For existing links to behavioural feedback, the corresponding status for this field will be listed under the column \"Feedback Status\". \n- Any candidates with conflicts between initial and double data entry will be listed under the 'Conflicts' column. Clicking on the candidate’s link will open up a new tab, directing the user to the Conflict Resolver for the corresponding field and visit label for that candidate. \n- A list of candidates for which data entry is incomplete for that particular instrument and visit label will be listed under \"Incomplete Candidates\". The ID of each candidate listed is a link to that candidate’s data entry page.\n';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('data_team_helper'), 'Data Team Helper',  'The Data Team Helper allows the users to find out what the outstanding behaviourial feedbacks, conflicts and incomplete forms for the given candidate/field/instrument by filtering for the given visit-Label and Instrument. This module will also display the \"Single Data_entry Completion Percentage\" for the given visit and instrument, only if the instrument is selected.\n\r The resulting table:\n - displays all fields from the selected instrument (or All Instruments if this feature was chosen) for the specified visit. \n - Under the column \"Names (Instrument_Fieldname)\", the given field name is clickable which allows the user to download the data for the given field/instrument in the .csv format, containing the data and data_entry (i.e complete, in_progress or null)  for every candidate for the given field and visit.\n- The \"Link to Bvl Feedback\" column contains links to pop-up feedback window, where feedback for a particular field and candidate was previously entered, based on the field-name. If such information was never entered, users will see \"N/A\". \n- For existing links to behavioural feedback, the corresponding status for this field will be listed under the column \"Feedback Status\". \n- Any candidates with conflicts between initial and double data entry will be listed under the \"Conflicts\" column. Clicking on the candidate\’s link will open up a new tab, directing the user to the Conflict Resolver for the corresponding field and visit label for that candidate. \n- A list of candidates for which data entry is incomplete for that particular instrument and visit label will be listed under \"Incomplete Candidates\". The ID of each candidate listed is a link to that candidate’s data entry page.\n','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The Data Team Helper allows the users to find out what the outstanding behaviourial feedbacks, conflicts and incomplete forms for the given candidate/field/instrument by filtering for the given visit-Label and Instrument. This module will also display the \"Single Data_entry Completion Percentage\" for the given visit and instrument, only if the instrument is selected.\n\r The resulting table:\n - displays all fields from the selected instrument (or All Instruments if this feature was chosen) for the specified visit. \n - Under the column \"Names (Instrument_Fieldname)\", the given field name is clickable which allows the user to download the data for the given field/instrument in the .csv format, containing the data and data_entry (i.e complete, in_progress or null)  for every candidate for the given field and visit.\n- The \"Link to Bvl Feedback\" column contains links to pop-up feedback window, where feedback for a particular field and candidate was previously entered, based on the field-name. If such information was never entered, users will see \"N/A\". \n- For existing links to behavioural feedback, the corresponding status for this field will be listed under the column \"Feedback Status\". \n- Any candidates with conflicts between initial and double data entry will be listed under the \"Conflicts\" column. Clicking on the candidate\’s link will open up a new tab, directing the user to the Conflict Resolver for the corresponding field and visit label for that candidate. \n- A list of candidates for which data entry is incomplete for that particular instrument and visit label will be listed under \"Incomplete Candidates\". The ID of each candidate listed is a link to that candidate’s data entry page.\n';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('data_integrity_flag'), 'Data Integrity','The Data Integrity module provides a direct way for users to view and update behavioural feedback at-a-glance, without requiring the user to navigate to the individual instrument forms or use the behavioural feedback pop-up window. \r\n\r\nThe Selection Filter allows users to search for existing feedback for a particular Visit Label, Instrument and User. Upon clicking \"Show Data\", the user can add a new flag or behavioural feedback comment within the table directly below the Selection Filter. Users can also search through existing behavioural feedback results within the third table on the page. When adding new behavioural feedback, the date on which the flag was created must be indicated, as well as the Flag Status from the dropdown menu, and any additional comments. The \"Save\" button must be clicked in order to save the new behavioural flag. Click \"Show updated data\" or refresh the page to see the most recent behavioural flag within the results table.\r\n\r\nWithin the results table (third table on the Data Integrity page), links under the \"Instrument\" column will redirect the user to a detailed summary of each field for that particular instrument along with links to behavioural feedback and to incomplete candidates. Users can also view the date the flag was submitted, the Flag Status, any comments, data cleaning feedback, and UserID. Note, Flag Status is based on the codes used in the dropdown of the second table, where 1=Ready for Review, 2= Review Completed, 3=Feedbacks Closed, and 4=Finalization.' ,'2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The Data Integrity module provides a direct way for users to view and update behavioural feedback at-a-glance, without requiring the user to navigate to the individual instrument forms or use the behavioural feedback pop-up window. \r\n\r\nThe Selection Filter allows users to search for existing feedback for a particular Visit Label, Instrument and User. Upon clicking \"Show Data\", the user can add a new flag or behavioural feedback comment within the table directly below the Selection Filter. Users can also search through existing behavioural feedback results within the third table on the page. When adding new behavioural feedback, the date on which the flag was created must be indicated, as well as the Flag Status from the dropdown menu, and any additional comments. The \"Save\" button must be clicked in order to save the new behavioural flag. Click \"Show updated data\" or refresh the page to see the most recent behavioural flag within the results table.\r\n\r\nWithin the results table (third table on the Data Integrity page), links under the \"Instrument\" column will redirect the user to a detailed summary of each field for that particular instrument along with links to behavioural feedback and to incomplete candidates. Users can also view the date the flag was submitted, the Flag Status, any comments, data cleaning feedback, and UserID. Note, Flag Status is based on the codes used in the dropdown of the second table, where 1=Ready for Review, 2= Review Completed, 3=Feedbacks Closed, and 4=Finalization.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('user_accounts'), 'User Accounts', 'This feature of LORIS allows an administrator to create accounts and set the Roles and Permissions for database users. Like many modules in LORIS, User Accounts has a Selection Filter which allows the user to quickly search for desired information. The Selection Filter panel can be hidden using the upward arrow icon , and reopened using the downward arrow icon. Once the appropriate user has been found, the profile can be viewed by selecting the \"Username\" outlined in navy text.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='This feature of LORIS allows an administrator to create accounts and set the Roles and Permissions for database users. Like many modules in LORIS, User Accounts has a Selection Filter which allows the user to quickly search for desired information. The Selection Filter panel can be hidden using the upward arrow icon , and reopened using the downward arrow icon. Once the appropriate user has been found, the profile can be viewed by selecting the \"Username\" outlined in navy text.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES ((SELECT helpID FROM (SELECT * FROM `help`) as temp WHERE hash=md5('user_accounts')), md5('edit_user'), 'Add or Edit User Accounts', 'On this page, the user may enter and modify detailed information including address, degree, position and password. By checking a series of boxes under \"Roles\" and \"Permissions\" an administrator-level user may add, change or remove a user’s access to areas or functions in the database. After making changes, the administrator must click \"Save\" to ensure the permissions are updated. Note that permissions may be \"Reset\" by selecting the appropriate button. The administrator may also return to the list of users by selecting \"Back\".' ,'2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='On this page, the user may enter and modify detailed information including address, degree, position and password. By checking a series of boxes under \"Roles\" and \"Permissions\" an administrator-level user may add, change or remove a user’s access to areas or functions in the database. After making changes, the administrator must click \"Save\" to ensure the permissions are updated. Note that permissions may be \"Reset\" by selecting the appropriate button. The administrator may also return to the list of users by selecting \"Back\".';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('instrument_builder'), 'Instrument Builder', 'The Instrument Builder module is designed to create new behavioural forms on the database. Existing instruments that were created using the instrument builder can be added under the \"Load Instrument (optional)\" heading. Most new instruments will be generated through the \"Create Instrument\" tab.\r\nThere are a series of buttons that specify the type of information each field in the form conveys.\r\n<b>Field Types, by Category :</b>\r\n<u>Information</u>\r\n• Header :: Used to specify a title for the page or section of the instrument. Text will appear in boldface at the centre of the page.\r\n• Label :: Functions as a subtitle to introduce a subset of questions\r\n• Scored Field :: Specifies any field that will have data entry. The type of scored field should be indicated under the \"data entry\" section\r\n<u>Data Entry</u>\r\n• Textbox :: Used for fields with free text, preferably short answers\r\n• Textarea :: Used for free text fields with longer inputs such as general comments, etc.\r\n• Dropdown :: Used for forced choice fields. The options for the dropdown menu need to be specified.  Once \"Dropdown\" is selected, the user will see an added row labeled as \"Dropdown option\". Once the option has been entered, press \"add option\". This new option should appear in the \"preview\" menu. The field \"not_answered\" will be automatically added to each dropdown menu. Once all options have been added, click \"add row\". For subsequent dropdown scored fields, previous dropdown options will be preserved. If the user would like to create a new dropdown menu, click \"reset\".\r\n• Multiselect :: Used for fields that have a select box where multiple options can be chosen.\r\n• Date :: Used for creating a date field such as Date of Birth\r\n• Numeric :: Used for creating a numeric field such as Height, Weight, etc.\r\n<u>Formatting</u>\r\n• Blank Line :: Can be used to separate sections within the same page of an instrument. The \"Question Name\" and \"Question Text\" can be left blank.\r\n• Page Break :: Used to add a new page within the instrument. The \"Question Text\" can be populated with the name of the new page, if desired.\r\n \r\n<b>Note on Question Names: </b>\r\n\"Question Name\" is the field name as it appears (only) in the back-end of the database. The \"Question Text\" will be seen by users on the database once the instrument has been uploaded. Users have the option of entering the same content into both the \"Question Name\" and \"Question Text\" boxes, but generally the \"Question Name\" is more brief and is formatted with the question number (ie. q1_*). Question names are unique and should not contain spaces. \r\n\r\nAfter each question entry, click \"add row\" to add the new field to the instrument code. \r\nThis should appear in table format at the bottom of the page. Each row can also be added to the table simply by pressing the enter key.\r\nIf a mistake was made while creating the instrument, users can directly edit the field names in the table at the bottom of the page. By clicking on the field name, a cursor should appear. The user can then make the appropriate changes and hit enter once finished. It is also possible to rearrange or delete fields using the \"Options\" column.\r\n \r\nOnce the user is satisfied with their instrument, it can be saved and validated.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='The Instrument Builder module is designed to create new behavioural forms on the database. Existing instruments that were created using the instrument builder can be added under the \"Load Instrument (optional)\" heading. Most new instruments will be generated through the \"Create Instrument\" tab.\r\nThere are a series of buttons that specify the type of information each field in the form conveys.\r\n<b>Field Types, by Category :</b>\r\n<u>Information</u>\r\n• Header :: Used to specify a title for the page or section of the instrument. Text will appear in boldface at the centre of the page.\r\n• Label :: Functions as a subtitle to introduce a subset of questions\r\n• Scored Field :: Specifies any field that will have data entry. The type of scored field should be indicated under the \"data entry\" section\r\n<u>Data Entry</u>\r\n• Textbox :: Used for fields with free text, preferably short answers\r\n• Textarea :: Used for free text fields with longer inputs such as general comments, etc.\r\n• Dropdown :: Used for forced choice fields. The options for the dropdown menu need to be specified.  Once \"Dropdown\" is selected, the user will see an added row labeled as \"Dropdown option\". Once the option has been entered, press \"add option\". This new option should appear in the \"preview\" menu. The field \"not_answered\" will be automatically added to each dropdown menu. Once all options have been added, click \"add row\". For subsequent dropdown scored fields, previous dropdown options will be preserved. If the user would like to create a new dropdown menu, click \"reset\".\r\n• Multiselect :: Used for fields that have a select box where multiple options can be chosen.\r\n• Date :: Used for creating a date field such as Date of Birth\r\n• Numeric :: Used for creating a numeric field such as Height, Weight, etc.\r\n<u>Formatting</u>\r\n• Blank Line :: Can be used to separate sections within the same page of an instrument. The \"Question Name\" and \"Question Text\" can be left blank.\r\n• Page Break :: Used to add a new page within the instrument. The \"Question Text\" can be populated with the name of the new page, if desired.\r\n \r\n<b>Note on Question Names: </b>\r\n\"Question Name\" is the field name as it appears (only) in the back-end of the database. The \"Question Text\" will be seen by users on the database once the instrument has been uploaded. Users have the option of entering the same content into both the \"Question Name\" and \"Question Text\" boxes, but generally the \"Question Name\" is more brief and is formatted with the question number (ie. q1_*). Question names are unique and should not contain spaces. \r\n\r\nAfter each question entry, click \"add row\" to add the new field to the instrument code. \r\nThis should appear in table format at the bottom of the page. Each row can also be added to the table simply by pressing the enter key.\r\nIf a mistake was made while creating the instrument, users can directly edit the field names in the table at the bottom of the page. By clicking on the field name, a cursor should appear. The user can then make the appropriate changes and hit enter once finished. It is also possible to rearrange or delete fields using the \"Options\" column.\r\n \r\nOnce the user is satisfied with their instrument, it can be saved and validated.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES ((SELECT helpID FROM (SELECT * FROM `help`) as temp WHERE hash=md5('user_accounts')),md5('my_preferences'), 'My Preferences', 'This module allows the user to modify first name, last name, email address, and current password, as well as Document Repository preferences. All changes made to the user’s preferences must be saved by clicking \"Save\" after completion. Information can be reset using the \"Reset\" button.','2014-09-01 00:00:00',NULL)
ON DUPLICATE KEY UPDATE content='This module allows the user to modify first name, last name, email address, and current password, as well as Document Repository preferences. All changes made to the user’s preferences must be saved by clicking \"Save\" after completion. Information can be reset using the \"Reset\" button.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1, md5('configuration'), 'Configuration', 'The Configuration Module allows you to edit configuration settings from the front end. The configuration values are stored in the database, instead of in the config.xml file. Any settings that are not currently in the Configuration Module can still be found and edited from the config.xml file.\r\n\r\nTo edit any configuration settings, navigate to the field that you\'d like to edit in the module, and edit or insert a new value.\r\n\r\nSome configuration settings can accept multiple values. For these settings, you can add additional fields by pressing the \"Add Field\" button. This will create an empty form area where you can insert new values. You can delete any of the settings by pressing the red delete button attached to the form.\r\n\r\nPress the submit button at the bottom of the page to save your changes. You must press the submit button that is on the page where you are making the changes for the changes to be stored in the database. If you press the submit button on another configuration page, it will not store any changes made on other pages.\r\n\r\nCare should be taken when editing the fields as there is currently no way to revert changes. You can reset the form to its values on page load by pressing the reset button. However, this will not undo any changes made before the submit button has been pressed.', '2014-09-01 00:00:00', NULL)
ON DUPLICATE KEY UPDATE content='The Configuration Module allows you to edit configuration settings from the front end. The configuration values are stored in the database, instead of in the config.xml file. Any settings that are not currently in the Configuration Module can still be found and edited from the config.xml file.\r\n\r\nTo edit any configuration settings, navigate to the field that you\'d like to edit in the module, and edit or insert a new value.\r\n\r\nSome configuration settings can accept multiple values. For these settings, you can add additional fields by pressing the \"Add Field\" button. This will create an empty form area where you can insert new values. You can delete any of the settings by pressing the red delete button attached to the form.\r\n\r\nPress the submit button at the bottom of the page to save your changes. You must press the submit button that is on the page where you are making the changes for the changes to be stored in the database. If you press the submit button on another configuration page, it will not store any changes made on other pages.\r\n\r\nCare should be taken when editing the fields as there is currently no way to revert changes. You can reset the form to its values on page load by pressing the reset button. However, this will not undo any changes made before the submit button has been pressed.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('mri_violations'),'MRI Protocol Violations','The MRI Violations Module has a Selection Filter function to allow users to search for a particular scan that violates MRI protocol. By clicking the button Show Data after selecting certain search options, a box will appear containing all the search results, which are organized by Patient Name, Project, Subproject, Site, Time Run, MincFile name, MincFile Violated, Series Description Or Scan Type, Problem, and Resolution Status. \r\n Clicking on a link under the MincFileViolated column will open a pop-up window of the scan on Brainbrowser. \r\n Clicking on a link under the Problem column will allow the user to see the issues for that particular patient and visit label. The issues are organized by Patient Name, CandID, Visit Label, Scan Type, Severity, Header, Value, ValidRange, ValidRegex, and SeriesUID. \r\n Once a particular MRI Protocol Violation has been resolved, the Resolution Status can be updated using the drop-down menu to select one of the following options: Reran, Emailed site/pending, Inserted, Rejected, Inserted with flag, Other. Otherwise, the drop-down menu is left as \"Unresolved\", serving as a message to other users that an issue still exists.', '2016-02-23 00:00:00', NULL)
ON DUPLICATE KEY UPDATE content='The MRI Violations Module has a Selection Filter function to allow users to search for a particular scan that violates MRI protocol. By clicking the button Show Data after selecting certain search options, a box will appear containing all the search results, which are organized by Patient Name, Project, Subproject, Site, Time Run, MincFile name, MincFile Violated, Series Description Or Scan Type, Problem, and Resolution Status. \r\n Clicking on a link under the MincFileViolated column will open a pop-up window of the scan on Brainbrowser. \r\n Clicking on a link under the Problem column will allow the user to see the issues for that particular patient and visit label. The issues are organized by Patient Name, CandID, Visit Label, Scan Type, Severity, Header, Value, ValidRange, ValidRegex, and SeriesUID. \r\n Once a particular MRI Protocol Violation has been resolved, the Resolution Status can be updated using the drop-down menu to select one of the following options: Reran, Emailed site/pending, Inserted, Rejected, Inserted with flag, Other. Otherwise, the drop-down menu is left as \"Unresolved\", serving as a message to other users that an issue still exists.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('training'),'Training','The Training Module allows users to view training content in three columns: Certifications to Complete, Completed Certifications, and Online Training. \r\n Certifications to Complete consists of available existing training modules that the user has not yet completed. Completed Certifications allow the user to browse the training content for any of the instruments that the user has already been certified for. Online Training allows the user to access training for certain instruments online.','2016-02-23 00:00:00', NULL)
ON DUPLICATE KEY UPDATE content='The Training Module allows users to view training content in three columns: Certifications to Complete, Completed Certifications, and Online Training. \r\n Certifications to Complete consists of available existing training modules that the user has not yet completed. Completed Certifications allow the user to browse the training content for any of the instruments that the user has already been certified for. Online Training allows the user to access training for certain instruments online.';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('survey_accounts'),'Survey Accounts','The Survey Accounts Module can be used to create a survey form, which creates a unique URL that can either be emailed to the participants to be completed online or loaded as a webpage on a desktop at the site for the participants to fill out during their visit.\r\n This page contains a list of all forms created for direct data entry by study participants. You can filter this list of surveys based on the Visit, Email, PSCID and Instrument. \r\n To create a survey, click on the \"Add Survey\" button. See additional help on the \"Add Survey\" page for information on how to create a survey. Once the survey has been created, click on the URL to access the online survey.\r\n Survey Status Information:\r\nCreated: Indicates that the survey was created. This is the default status once a survey is created using the \"Add Survey\" page.\r\n Sent: Indicates that the survey was created and an email with the survey link was sent to the participant. This is the default status once a survey is created and sent by email using the \"Add Survey\" window. \r\n In Progress: indicates that the survey was accessed. This status can either be attained when data entry staff click on the URL to load the page for the participants or when participants access the link sent to them via email. \r\n Complete: This indicates that the survey was completed and submitted. After this stage, the participant will not be able to go back and change his/her entries. Clicking on the URL will display a page with the message \"Data has already been submitted\".','2016-02-23 00:00:00', NULL)
ON DUPLICATE KEY UPDATE content='The Survey Accounts Module can be used to create a survey form, which creates a unique URL that can either be emailed to the participants to be completed online or loaded as a webpage on a desktop at the site for the participants to fill out during their visit.\r\n This page contains a list of all forms created for direct data entry by study participants. You can filter this list of surveys based on the Visit, Email, PSCID and Instrument. \r\n To create a survey, click on the \"Add Survey\" button. See additional help on the \"Add Survey\" page for information on how to create a survey. Once the survey has been created, click on the URL to access the online survey.\r\n Survey Status Information:\r\nCreated: Indicates that the survey was created. This is the default status once a survey is created using the \"Add Survey\" page.\r\n Sent: Indicates that the survey was created and an email with the survey link was sent to the participant. This is the default status once a survey is created and sent by email using the \"Add Survey\" window. \r\n In Progress: indicates that the survey was accessed. This status can either be attained when data entry staff click on the URL to load the page for the participants or when participants access the link sent to them via email. \r\n Complete: This indicates that the survey was completed and submitted. After this stage, the participant will not be able to go back and change his/her entries. Clicking on the URL will display a page with the message \"Data has already been submitted\".';

INSERT INTO `help` (parentID, hash, topic, content, created, updated) VALUES (-1,md5('dataquery'),'Data Query Tool','The Data Query Tool (DQT) is a simple and easy-to-use interface to your LORIS database. The DQT enables users to query and download data.\r\n The DQT can be used to define or use your query by using the following tabs:\r\n Info: \r\n A quick summary of each of the DQT tabs. It also states the time of last data cache update. \r\n\r\n Define Fields \r\n Define the fields to be added to your query here. \r\n\r\n Define Filters \r\n Define the criteria to filter the data for your query here. \r\n\r\n View Data \r\n See the results of your query. \r\n \r\n Statistical Analysis \r\n Visualize or see basic statistical measures from your query here. \r\n\r\n Load Saved Query \r\n Load a previously saved query (by name) by selecting from this menu. \r\n\r\n Manage Saved Queries \r\n Either save your current query or see the criteria of previously saved queries here. \r\n\r\n <b>Define Fields</b>\r\n The \"Define Fields\" tab is where you select the data categories and the specific data fields that you want added to your query. By default, all categories of data fields are displayed in a list when you first enter the tab. If you click on any category, its field names and field descriptions will appear in a table. If the number of fields in the chosen category exceeds the display limit per page, the results may be displayed on subsequent pages within the table, accessible via the page number buttons found by scrolling toward the bottom of the page. Any fields that are defined for the current query are listed on the right-hand side (subject to change). If there are no fields defined for the current query, this list is not shown. Time points can be specified within the field in the \"Define Fields\" tab or in the \"Define Filters\" tab. \r\n\r\n The options to add fields to your query are as follows: \r\n\r\n <u>Option 1:</u> Add Using Dropdown \r\n Fields can be searched for using the list of categories of data fields. After clicking the desired instrument, a list of fields are displayed. Clicking on a field row will highlight it and add it to the list of selected fields for your current query. \r\n\r\n <u>Option 2:</u> Search Within Instrument \r\n Fields can be searched for using the search bar. Once the user starts typing, all matches will be displayed in an active list. Once the desired field is displayed, the field must be clicked to be added into the query. \r\n\r\n <u>Option 3:</u> Add All \r\n If all fields from a particular category should be included in the query, use this method. By clicking the \"Add All\" button above the list of categories, all fields from the category will be added. \r\n\r\n <u>Option 4:</u> Load a Saved Query \r\n To reload a saved query, click on the \"Load Saved Query\" tab. User Saved Queries and Shared Saved Queries will appear in a dropdown. User Saved Queries are queries that the current user has saved, and are listed according to Query Name. Shared Saved Queries are publicly shared, and are listed according to the user who created it and the Query Name. Once a query is selected, the DQT will retrieve and load the query fields and filters that were selected when the query was initially created. This will be displayed under the \"Define Fields\" and \"Define Filters\" tabs, respectively. \r\n\r\n If you wish to remove fields from your query, you must find the field from the list (using the Search Within Instrument search bar or in the instrument list of fields) and click on the highlighted field. This can be confirmed by checking that the field no longer appears in your list of selected fields. \r\n\r\n If you wish to remove all currently selected fields from your query, you can click \"Clear Query\" in the list of Fields. If you wish to remove all fields from a specific category, click the \"Remove All\" button above the list of categories. \r\n\r\n Once all desired fields are listed under \"Fields\", continue to the \"Define Filters\" tab to add filters to your query, or go directly to the \"View Data\" tab if your query does not require filters. \r\n\r\n <b>Define Filters</b> \r\n The \"Define Filters\" tab is where you define the criteria to filter the data for your query. Filters can be applied on any field in order to limit the set of results returned by a query. For example, you can extract data collected only at one specific site or from a particular visit. Furthermore, multiple filters can be applied with either \"And\" or \"Or\" logic. The filters are candidate specific, no longer time point and candidate specific. \r\n\r\n The data fields are grouped by category. To add a filter, select a category using the dropdown. A second dropdown will appear with all the data fields in that category. Once a data field is specified, dropdowns to specify the \"Operator\" and \"Value\" will appear.  \r\n\r\n Possible operators are as follows: \r\n • = equal to \r\n • != does not equal \r\n • <= less than or equal to \r\n • >= greater than or equal to \r\n • startsWith: filter for values starting with a specific character or string \r\n • contains:  filter for values containing a specific character or string \r\n\r\n To add additional filters, click the \"Add Rule\" button and follow the instructions above. To delete any unwanted filters, click the \"Delete\" button within the specific filter. \r\n\r\n By default, the filters are set to \"And\" logic. Previously, only \"And\" logic was applied. To switch to the \"Or\" logic, click on the \"Or\" button. This sets the operator for the whole group of filters. To add a new group, click the \"Add Group\" button. This allows you to have nested filters with both \"And\" and \"Or\" logical operators. \"And\" indicates that all of its operands are true. \"Or\" indicates inclusive or, which means that one or more of its operands is true. \r\n\r\n <b>View Data</b> \r\n The \"View Data\" tab executes queries, displays query results, and allows users to download data. Select how you want the data to be arranged using the Data dropdown (cross-sectional or longitudinal). Click the \"Run Query\" button to execute the current query on the database based on the defined fields and filters. Results can be also sorted by field by clicking on the table\'s column headers. The number of results displayed per page can be modified using the \"Maximum rows per page dropdown\" at the bottom of the results table. \r\n\r\n After running a query and viewing the results, click the \"Download Table Data as CSV\" button to save the query output dataset to your computer as a comma-separated value file. If any files are included in the query output, click \"Download Data as ZIP\" to save compressed packages of the files and data to your computer. \r\n\r\n The query can also be saved for reuse, to avoid constructing the query from scratch in future. Go to the \"Manage Saved Queries\" tab and then click the \"Save Query\" button. A pop-up dialog will appear. Enter a descriptive query name. If you would like the query to be publicly shared, click on the checkbox. Then click \"Save query\" to complete the process, and the currently defined fields and filters will be saved under the specified query name. \r\n\r\n This saved query should now appear under the \"Manage Saved Queries\" tab in the \"Your currently saved queries\" table. New fields can be selected and saved under the same name to directly update the current query. See the help section for \"Saved Queries\" for further information on actions that can be performed on these previously created queries. \r\n\r\n <b>Manage Saved Queries</b> \r\n The \"Manage Saved Queries\" tab organizes new or previously saved queries. The query name, selected fields and filters for each saved query are displayed in the table. Clicking on any column header (e.g. \"Query Name\") will sort the list by that column. \r\n\r\n The current query can be saved by clicking the \"Save Current Query\" button. A pop-up dialog will appear. Enter a descriptive query name. If you would like the query to be publicly shared, click on the checkbox. Then click \"Save query\" to complete the process, and the currently defined fields and filters will be saved under the specified query name. This saved query should now appear under the \"Manage Saved Queries\" tab in the \"Your currently saved queries\" table. New fields can be selected and saved under the same name to directly update the current query. \r\n\r\n To reload a saved query, click on the \"Load Saved Query\" tab. User Saved Queries and Shared Saved Queries will appear in a dropdown. User Saved Queries are queries that the current user has saved, and are listed according to Query Name. Shared Saved Queries are publicly shared, and are listed according to the user who created it and the Query Name. Once a query is selected, the DQT will retrieve and load the query fields and filters that were selected when the query was initially created. This will be displayed under the \"Define Fields\" and \"Define Filters\" tabs, respectively.  \r\n','2016-04-01 00:00:00', NULL)
ON DUPLICATE KEY UPDATE content='The Data Query Tool (DQT) is a simple and easy-to-use interface to your LORIS database. The DQT enables users to query and download data.\r\n The DQT can be used to define or use your query by using the following tabs:\r\n Info: \r\n A quick summary of each of the DQT tabs. It also states the time of last data cache update. \r\n\r\n Define Fields \r\n Define the fields to be added to your query here. \r\n\r\n Define Filters \r\n Define the criteria to filter the data for your query here. \r\n\r\n View Data \r\n See the results of your query. \r\n \r\n Statistical Analysis \r\n Visualize or see basic statistical measures from your query here. \r\n\r\n Load Saved Query \r\n Load a previously saved query (by name) by selecting from this menu. \r\n\r\n Manage Saved Queries \r\n Either save your current query or see the criteria of previously saved queries here. \r\n\r\n <b>Define Fields</b>\r\n The \"Define Fields\" tab is where you select the data categories and the specific data fields that you want added to your query. By default, all categories of data fields are displayed in a list when you first enter the tab. If you click on any category, its field names and field descriptions will appear in a table. If the number of fields in the chosen category exceeds the display limit per page, the results may be displayed on subsequent pages within the table, accessible via the page number buttons found by scrolling toward the bottom of the page. Any fields that are defined for the current query are listed on the right-hand side (subject to change). If there are no fields defined for the current query, this list is not shown. Time points can be specified within the field in the \"Define Fields\" tab or in the \"Define Filters\" tab. \r\n\r\n The options to add fields to your query are as follows: \r\n\r\n <u>Option 1:</u> Add Using Dropdown \r\n Fields can be searched for using the list of categories of data fields. After clicking the desired instrument, a list of fields are displayed. Clicking on a field row will highlight it and add it to the list of selected fields for your current query. \r\n\r\n <u>Option 2:</u> Search Within Instrument \r\n Fields can be searched for using the search bar. Once the user starts typing, all matches will be displayed in an active list. Once the desired field is displayed, the field must be clicked to be added into the query. \r\n\r\n <u>Option 3:</u> Add All \r\n If all fields from a particular category should be included in the query, use this method. By clicking the \"Add All\" button above the list of categories, all fields from the category will be added. \r\n\r\n <u>Option 4:</u> Load a Saved Query \r\n To reload a saved query, click on the \"Load Saved Query\" tab. User Saved Queries and Shared Saved Queries will appear in a dropdown. User Saved Queries are queries that the current user has saved, and are listed according to Query Name. Shared Saved Queries are publicly shared, and are listed according to the user who created it and the Query Name. Once a query is selected, the DQT will retrieve and load the query fields and filters that were selected when the query was initially created. This will be displayed under the \"Define Fields\" and \"Define Filters\" tabs, respectively. \r\n\r\n If you wish to remove fields from your query, you must find the field from the list (using the Search Within Instrument search bar or in the instrument list of fields) and click on the highlighted field. This can be confirmed by checking that the field no longer appears in your list of selected fields. \r\n\r\n If you wish to remove all currently selected fields from your query, you can click \"Clear Query\" in the list of Fields. If you wish to remove all fields from a specific category, click the \"Remove All\" button above the list of categories. \r\n\r\n Once all desired fields are listed under \"Fields\", continue to the \"Define Filters\" tab to add filters to your query, or go directly to the \"View Data\" tab if your query does not require filters. \r\n\r\n <b>Define Filters</b> \r\n The \"Define Filters\" tab is where you define the criteria to filter the data for your query. Filters can be applied on any field in order to limit the set of results returned by a query. For example, you can extract data collected only at one specific site or from a particular visit. Furthermore, multiple filters can be applied with either \"And\" or \"Or\" logic. The filters are candidate specific, no longer time point and candidate specific. \r\n\r\n The data fields are grouped by category. To add a filter, select a category using the dropdown. A second dropdown will appear with all the data fields in that category. Once a data field is specified, dropdowns to specify the \"Operator\" and \"Value\" will appear.  \r\n\r\n Possible operators are as follows: \r\n • = equal to \r\n • != does not equal \r\n • <= less than or equal to \r\n • >= greater than or equal to \r\n • startsWith: filter for values starting with a specific character or string \r\n • contains:  filter for values containing a specific character or string \r\n\r\n To add additional filters, click the \"Add Rule\" button and follow the instructions above. To delete any unwanted filters, click the \"Delete\" button within the specific filter. \r\n\r\n By default, the filters are set to \"And\" logic. Previously, only \"And\" logic was applied. To switch to the \"Or\" logic, click on the \"Or\" button. This sets the operator for the whole group of filters. To add a new group, click the \"Add Group\" button. This allows you to have nested filters with both \"And\" and \"Or\" logical operators. \"And\" indicates that all of its operands are true. \"Or\" indicates inclusive or, which means that one or more of its operands is true. \r\n\r\n <b>View Data</b> \r\n The \"View Data\" tab executes queries, displays query results, and allows users to download data. Select how you want the data to be arranged using the Data dropdown (cross-sectional or longitudinal). Click the \"Run Query\" button to execute the current query on the database based on the defined fields and filters. Results can be also sorted by field by clicking on the table\'s column headers. The number of results displayed per page can be modified using the \"Maximum rows per page dropdown\" at the bottom of the results table. \r\n\r\n After running a query and viewing the results, click the \"Download Table Data as CSV\" button to save the query output dataset to your computer as a comma-separated value file. If any files are included in the query output, click \"Download Data as ZIP\" to save compressed packages of the files and data to your computer. \r\n\r\n The query can also be saved for reuse, to avoid constructing the query from scratch in future. Go to the \"Manage Saved Queries\" tab and then click the \"Save Query\" button. A pop-up dialog will appear. Enter a descriptive query name. If you would like the query to be publicly shared, click on the checkbox. Then click \"Save query\" to complete the process, and the currently defined fields and filters will be saved under the specified query name. \r\n\r\n This saved query should now appear under the \"Manage Saved Queries\" tab in the \"Your currently saved queries\" table. New fields can be selected and saved under the same name to directly update the current query. See the help section for \"Saved Queries\" for further information on actions that can be performed on these previously created queries. \r\n\r\n <b>Manage Saved Queries</b> \r\n The \"Manage Saved Queries\" tab organizes new or previously saved queries. The query name, selected fields and filters for each saved query are displayed in the table. Clicking on any column header (e.g. \"Query Name\") will sort the list by that column. \r\n\r\n The current query can be saved by clicking the \"Save Current Query\" button. A pop-up dialog will appear. Enter a descriptive query name. If you would like the query to be publicly shared, click on the checkbox. Then click \"Save query\" to complete the process, and the currently defined fields and filters will be saved under the specified query name. This saved query should now appear under the \"Manage Saved Queries\" tab in the \"Your currently saved queries\" table. New fields can be selected and saved under the same name to directly update the current query. \r\n\r\n To reload a saved query, click on the \"Load Saved Query\" tab. User Saved Queries and Shared Saved Queries will appear in a dropdown. User Saved Queries are queries that the current user has saved, and are listed according to Query Name. Shared Saved Queries are publicly shared, and are listed according to the user who created it and the Query Name. Once a query is selected, the DQT will retrieve and load the query fields and filters that were selected when the query was initially created. This will be displayed under the \"Define Fields\" and \"Define Filters\" tabs, respectively.  \r\n';